// --------------------------------------------------- 
// Patrick Rudolph
// Project #1 | Frequency Mapping
//
// MAT 259 | Visualizing Information | Winter 2011
// Media Arts and Technology
// University of California Santa Barbara
// --------------------------------------------------- 

import de.bezier.data.sql.*;

// --------------------------------------------------- 
//   GLOBAL VARIABLES
// --------------------------------------------------- 
MySQL db;
String user     = "mat259";
String pass     = "V1sual1zat1on";
String database = "spl_all";

String[][] topics = new String[5][2];

// --------------------------------------------------- 
//   INITIALIZING (runs only once)
// --------------------------------------------------- 
void setup()
{
  size(100,100); 
  
  topics[0][0] = "WHERE title LIKE '%Apple%' ";
  topics[0][1] = "apple";
  topics[1][0] = "WHERE title LIKE '%green' ";
  topics[1][1] = "green";
  topics[2][0] = "WHERE title LIKE '%unemploy%' ";
  topics[2][1] = "unemploy";
  topics[3][0] = "WHERE title LIKE 'Harry Potter%' ";
  topics[3][1] = "harrypotter";
  topics[4][0] = "WHERE title LIKE '%9/11%' ";
  topics[4][1] = "911";
  
  
  println("Welcome. This program loads data for project #1 from tango and saves it to a file.");
  
  // connect to database
  print("Connecting to database.. ");
  db = new MySQL( this, "tango.mat.ucsb.edu", database, user, pass );  
  
  if( db.connect() ) 
  {
    println("done.");

    for(int t = 0; t < topics.length; t++)
    {
      int[] items = new int[365*6+5]; // 365 days x 6 years (5 days as buffer)
      
      String query = "";
      query = "SELECT unix_timestamp(ckoutDateTime) FROM transactionsall ";
      query += topics[t][0];
      query += "AND year(ckoutDateTime) >= 2005 AND year(ckoutDateTime) <= 2010;";
      // check subjects additionally to topics only?
      
      
      // query database
      print("Loading data for topic #" + t + ".. ");
      db.query(query);
      while(db.next())
      {
        // substract the unix timestamp for the first day of visualization
        // 1104566400 = Sat, 01 Jan 2005 00:00:00 GMT-8
        // divide by 86400 to get the number of days from 01/01/2005
        int d = Math.round((db.getInt(1)-1104566400)/86400);
        if(d>=0) items[d]++;
      }
      println("done.");

      // parse/filter
      
      
      // write to file
      String[] saveString = new String[items.length];
      for(int i = 0; i < items.length; i++)
        saveString[i] = Integer.toString(items[i]);
        
      saveStrings("../"+topics[t][1]+".txt",saveString);     

    }
    print("Closing database.. ");
    db.close();
    println("done.");
  }
  else
  {
    // connection failed
    print("failed.");
  }
  
}


// --------------------------------------------------- 
//   DRAWING (runs at framerate, default 60 frames/s)
// --------------------------------------------------- 
void draw() {}
